<template>
  <div>
    <hero-section
      title="Gaël Demette"
      subtitle="aka Panda"
    >
      <template #leftMedia>
        <p class="image is-64x64">
          <img src="~/assets/svg/avatar.svg">
        </p>
      </template>
    </hero-section>
    <section class="container">
      <main class="content">
        <h2>{{ $t('about_me') }}</h2>
        <div class="tags">
          <span class="tag is-link">{{ $t('speaker') }}</span>
          <span class="tag is-link">{{ $t('open_source_contributor') }}</span>
        </div>
        <p>
          {{ $t('about_me_p1', { age: cv.calculateAge() }) }}
        </p>
        <p>{{ $t('about_me_p2') }}</p>
        <p>
          {{ $t('about_me_p3') }}
        </p>
        <p>
          {{ $t('about_me_p4') }}
        </p>
        <h2>{{ $t('my_skills') }}</h2>
        <p class="is-size-7">
          {{ $t('last_update', { date: cv.formatDate(cv.lastUpdateDate) }) }}
        </p>
        <div class="columns">
          <div class="column is-narrow">
            <ul class="tags-tabs">
              <li :class="{ 'is-active': sortBy === 'lastUsed' }">
                <nuxt-link
                  class="is-link"
                  :to="{ query: {} }"
                >
                  {{ $t('sort_by_recent') }}
                </nuxt-link>
              </li>
              <li :class="{ 'is-active': sortBy === 'preference' }">
                <nuxt-link
                  class="is-link"
                  :to="{ query: { ...route.query, sort: 'preference', ...(route.query.tag ? {} : { tag: undefined }) } }"
                >
                  {{ $t('sort_by_preference') }}
                </nuxt-link>
              </li>
              <li :class="{ 'is-active': sortBy === 'name' }">
                <nuxt-link
                  class="is-link"
                  :to="{ query: { ...route.query, sort: 'name', ...(route.query.tag ? {} : { tag: undefined }) } }"
                >
                  {{ $t('sort_by_alpha') }}
                </nuxt-link>
              </li>
            </ul>
          </div>
          <div class="column">
            <div class="columns is-multiline">
              <div class="column is-full">
                <h3 class="is-size-5">
                  {{ $t('development') }}
                </h3>
                <div class="tags">
                  <nuxt-link
                    v-for="tech in getTechnologies('development')"
                    :key="tech.id"
                    class="tag is-info is-light"
                    :class="{ 'is-selected': tech.id === selectedTag }"
                    :to="{ query: { ...route.query, tag: tech.id === selectedTag ? undefined : tech.id } }"
                  >{{ tech.name }}</nuxt-link>
                </div>
              </div>
              <div class="column is-full">
                <h3 class="is-size-5">
                  {{ $t('system_admin') }}
                </h3>
                <div class="tags">
                  <nuxt-link
                    v-for="tech in getTechnologies('sysadmin')"
                    :key="tech.id"
                    class="tag is-info is-light"
                    :class="{ 'is-selected': tech.id === selectedTag }"
                    :to="{ query: { ...route.query, tag: tech.id === selectedTag ? undefined : tech.id } }"
                  >{{ tech.name }}</nuxt-link>
                </div>
              </div>
              <div class="column is-full">
                <h3 class="is-size-5">
                  {{ $t('project_management_tools') }}
                </h3>
                <div class="tags">
                  <nuxt-link
                    v-for="tech in getTechnologies('tools')"
                    :key="tech.id"
                    class="tag is-info is-light"
                    :class="{ 'is-selected': tech.id === selectedTag }"
                    :to="{ query: { ...route.query, tag: tech.id === selectedTag ? undefined : tech.id } }"
                  >{{ tech.name }}</nuxt-link>
                </div>
              </div>
              <div class="column is-full">
                <h3 class="is-size-5">
                  {{ $t('soft_skills') }}
                </h3>
                <div class="tags">
                  <nuxt-link
                    v-for="tech in getTechnologies('soft')"
                    :key="tech.id"
                    class="tag is-info is-light"
                    :class="{ 'is-selected': tech.id === selectedTag }"
                    :to="{ query: { ...route.query, tag: tech.id === selectedTag ? undefined : tech.id } }"
                  >{{ tech.name }}</nuxt-link>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="mt-6">
          <h2>{{ $t('professional_experience') }}</h2>
          <ul>
            <li
              v-for="(exp, index) in cv.experiences"
              :key="index"
            >
              <span v-if="exp.current">
                {{ $t('since', { date: cv.formatDate(exp.startDate), title: exp.title, company: exp.company }) }}
              </span>
              <span v-else>
                {{ $t('experience_period', { startDate: cv.formatDate(exp.startDate), endDate: cv.formatDate(exp.endDate), title: exp.title, company: exp.company || '' }) }}
              </span>
              <p v-if="exp.description">
                {{ exp.description }}
              </p>
              <ul v-if="exp.achievements && exp.achievements.length">
                <li
                  v-for="(achievement, i) in exp.achievements"
                  :key="i"
                >
                  {{ achievement }}
                </li>
              </ul>
              <div
                v-if="exp.technologies && exp.technologies.length"
                class="tags mb-6"
              >
                <nuxt-link
                  v-for="techId in exp.technologies"
                  :key="techId"
                  class="tag is-info is-light"
                  :class="{ 'is-selected': techId === selectedTag }"
                  :to="{ query: { ...route.query, tag: techId === selectedTag ? undefined : techId } }"
                >{{ getTechName(techId) }}</nuxt-link>
              </div>
            </li>
          </ul>
          <h2>{{ $t('education') }}</h2>
          <ul>
            <li
              v-for="(edu, index) in cv.education"
              :key="index"
            >
              {{ $t('education_period', { startDate: cv.formatDate(edu.startDate), endDate: cv.formatDate(edu.endDate), degree: edu.degree, school: edu.school, location: edu.location || '' }) }}
            </li>
          </ul>
          <h2>{{ $t('languages') }}</h2>
          <ul>
            <li
              v-for="(lang, index) in cv.personal.languages"
              :key="index"
            >
              {{ $t('language_level', { name: lang.name, level: lang.level }) }}
            </li>
          </ul>
        </div>
      </main>
    </section>
  </div>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue'
import { useCV } from '../composables/use-cv'

const route = useRoute()

const cv = useCV()
const sortBy = ref('lastUsed')
const selectedTag = ref('')

// Initialize values from URL query parameters on page load
onMounted(() => {
  if (route.query.tag) {
    selectedTag.value = route.query.tag.toString()
  }

  if (route.query.sort && ['lastUsed', 'preference', 'name'].includes(route.query.sort.toString())) {
    sortBy.value = route.query.sort.toString()
  }
})

// Update local state when route changes
watch(() => route.query, (newQuery) => {
  if (newQuery.tag) {
    selectedTag.value = newQuery.tag.toString()
  }
  else {
    selectedTag.value = ''
  }

  if (newQuery.sort && ['lastUsed', 'preference', 'name'].includes(newQuery.sort.toString())) {
    sortBy.value = newQuery.sort.toString()
  }
  else {
    sortBy.value = 'lastUsed'
  }
}, { immediate: true })

const getTechnologies = (category) => {
  return cv.sortTechnologies(category, sortBy.value)
}

const getTechName = (techId) => {
  // Check in each technology category (all are now object-based)
  for (const category of ['development', 'sysadmin', 'tools', 'soft']) {
    // Check if the technology exists in this category
    if (cv.technologies[category] && cv.technologies[category][techId]) {
      return cv.technologies[category][techId].name
    }
  }

  // If not found in structured data, return the ID as fallback
  return techId
}
</script>

<style lang="scss" scoped>
  main {
    margin: 20px 0;
  }

  .tags-tabs {
    display: block;
    margin-left: 0;
    li {
      margin: 20px 0;
      display: block;
      &:after {
        content: " ➡";
      }
    }
    .is-active .is-link {
      font-weight: bold;
    }
    .is-link {
      text-decoration: underline;
    }
  }

  .tech-controls {
    margin-bottom: 1.5rem;
  }

  .tags {
    margin-top: 0.5rem;

    &.is-inline {
      display: inline-flex;
      margin-left: 0.5rem;
      margin-top: 0;
    }
  }

  .tag {
    cursor: pointer;
    transition: all 0.2s ease;

    &.is-selected {
      background-color: #3e8ed0 !important;
      color: white !important;
      transform: scale(1.05);
    }
  }

  .notification {
    padding: 0.75rem 1.25rem;
    margin-top: 1rem;
  }
</style>
